jQuery(function($){
    "use strict";
    foodsearch_menudropdown();
    foodsearch_choiceGroupdropdown();
    foodsearch_restaurantdropdown();
    foodsearch_selectdropdownFiled();
    foodsearch_initailizeSelect2();
    foodsearch_itemcategoriesinitailize();

    // on remove button click
    jQuery('body').on('click', 'a.fds-remove', function(e){

        e.preventDefault();
        var button = jQuery(this);
        button.prev().css('background-image','none'); // emptying the hidden field
        button.hide().prev().html('<i class="fds-icon fds-camera"></i>');
    });
    foodsearch_choicegroupOption();

});

jQuery('span.slider').on('click',function(){
    "use strict";
    if(jQuery(this).parents('label.switch').find('input').val()!=1) {
        jQuery(this).parents('label.switch').find('input').val(1);
    }
    else{
        jQuery(this).parents('label.switch').find('input').val(0)
    }
});


jQuery(document).on('click','div#restaurants_menu_meta_filed table tr td a.menu-items',function () {
    "use strict";
    var id = jQuery(this).attr('id');
    var content = '';

    jQuery.ajax({
        type: "post",
        dataType: "json",
        url:menubuilder_front_strings.site_url + 'wp/v1/menu-item-list-bymid',
        data:  {
            id: id
        },            
        beforeSend: function (xhr) {
            if(menubuilder_front_strings.adminCheck!='true'){
                xhr.setRequestHeader('X-WP-Nonce', menubuilder_front_strings.wpnonce);
           }  
        },
        success: function(data){
            jQuery(".menu-items-area"+id).html(data.html).toggle(500);
            jQuery( "#sortable" ).sortable({
                'items': 'tr',
                'placeholder': "ui-state-highlight",
                'axis': 'y',
                'update' : function(e, ui) {
                    var order               =   jQuery('#sortable').sortable('serialize');
                    console.log(order);
                     var queryString = { "action": "update-menu-item-order", "order" : order};
                    //send the data through ajax
                    jQuery.ajax({
                        type: 'POST',
                        url: ajaxurl,
                        data: queryString,
                        cache: false,
                        dataType: "html",
                        success: function(data){

                        },
                        error: function(html){

                        }
                    });

                }});
            jQuery( "#sortable" ).disableSelection();
        }
    });

});

jQuery(document).on('click','div#restaurants_menu_meta_filed table tr td table tr td a.choice-groups',function () {
    "use strict";
    var id = jQuery(this).attr('id');
    jQuery.ajax({
        type: "post",
        dataType: "json",
        url:menubuilder_front_strings.site_url + 'wp/v1/food-choice-groups-bymid',
        data:  {
            id: id
        },            
        beforeSend: function (xhr) {
            if(menubuilder_front_strings.adminCheck!='true'){
                xhr.setRequestHeader('X-WP-Nonce', menubuilder_front_strings.wpnonce);
           }  
        },
        success: function(data){
            content = data;
            jQuery(".choice-groups-area"+id).html(data.html).toggle(500);
        }
    });

});


jQuery('button#myBtn').on('click',function(){
    "use strict";
    foodsearch_showSidebarPopup('add',jQuery(this).attr('data-type'));
});
jQuery('span#closeSaveBtn').on('click',function(){
    "use strict";
    jQuery(".menu-form form.addform").animate({
        right: -600
    }, "slow",'linear',function(){
        jQuery('.menu-form').toggleClass('open').hide();
    });
    jQuery('.result-status').html('');
    jQuery('.filed-group-con').html('');
    //

});
jQuery('span#closeUpdateBtn').on('click',function(){
    "use strict";
    jQuery(".menu-form form.updateform").animate({
        right: -600
    }, "slow",'linear',function(){
        jQuery('.menu-form').toggleClass('open').hide();
    });

    jQuery('.result-status').html('');
    jQuery('.update-filed-group-con').html('');
    //

});

jQuery(document).on('click','a.edit-menu',function (e) {
    "use strict";
    e.preventDefault();
    jQuery('.result-status').hide();
    foodsearch_showSidebarPopup('update');
    var id = jQuery(this).attr('data-id');
    jQuery('.update-text-block').html('Edit: '+jQuery(this).attr('data-title')).show();
    jQuery.ajax({
        type: "post",
        dataType: "json",
        url:menubuilder_front_strings.site_url + 'wp/v1/food-menu-itemedit-byid',
        data:  {
            id: id
        },            
        beforeSend: function (xhr) {
            if(menubuilder_front_strings.adminCheck!='true'){
                xhr.setRequestHeader('X-WP-Nonce', menubuilder_front_strings.wpnonce);
           }  
        },
        success: function(data){
            jQuery('span.spin').hide();
            jQuery('.update-filed-group-con').html(data.html);
            foodsearch_restaurantdropdown();
            foodsearch_selectdropdownFiled();
            jQuery('.update-filed-group-con').show();
            jQuery('.result-status').show();

        }
    });
});
jQuery(document).on('click','a.edit-menu-item',function (e) {
    "use strict";
    e.preventDefault();
    jQuery('.result-status').hide();
    foodsearch_showSidebarPopup('update');
    var id = jQuery(this).attr('data-id');
    jQuery('.update-text-block').html('Edit: '+jQuery(this).attr('data-title')).show();

    jQuery.ajax({
        type: "post",
        dataType: "json",
        url:menubuilder_front_strings.site_url + 'wp/v1/food-menuitm-detail-bymid',
        data:  {
            id: id
        },            
        beforeSend: function (xhr) {
            if(menubuilder_front_strings.adminCheck!='true'){
                xhr.setRequestHeader('X-WP-Nonce', menubuilder_front_strings.wpnonce);
           }  
        },
        success: function(data){
            jQuery('span.spin').hide();
            jQuery('.update-filed-group-con').html(data.html);
            foodsearch_itemcategoriesinitailize();
            foodsearch_selectdropdownFiled();
            foodsearch_choiceGroupdropdown();
            foodsearch_extendVariationFileds();
            foodsearch_menudropdown();
            jQuery('.update-filed-group-con').show();

        }
    });
});
jQuery(document).on('click','a.edit-choice-group',function (e) {
    "use strict";
    e.preventDefault();
    jQuery('.result-status').hide();
    foodsearch_showSidebarPopup('update');
    var id = jQuery(this).attr('data-id');
    jQuery('.update-text-block').html('Edit: '+jQuery(this).attr('data-title')).show();

    jQuery.ajax({
        type: "post",
        dataType: "json",
        url:menubuilder_front_strings.site_url + 'wp/v1/food-choicegroup-detail-bymid',
        data:  {
            id: id
        },            
        beforeSend: function (xhr) {
           if(menubuilder_front_strings.adminCheck!='true'){
                xhr.setRequestHeader('X-WP-Nonce', menubuilder_front_strings.wpnonce);
}  
        },
        success: function(data){
            jQuery('span.spin').hide();
            jQuery('.update-filed-group-con').html(data.html);
            foodsearch_choicegroupOption();
            foodsearch_initailizeSelect2();
            foodsearch_restaurantdropdown();
            jQuery('.update-filed-group-con').show();

        }
    });
});

jQuery(document).on('click', '#menuSaveBtn',function () {
    "use strict";
    var _this = jQuery(this);
    _this.prop('disabled');
    var from = _this.parents('form');
    var formData = from.serialize();
    var this_html = _this.html();
    
    _this.html('<div class="fds-inline-loader"><div class="fds-loader"></div></div>');
    jQuery.ajax({
        type: "post",
        dataType: "json",
        url:menubuilder_front_strings.site_url + 'wp/v1/create-menu',
        data: formData,            
        beforeSend: function (xhr) {
           if(menubuilder_front_strings.adminCheck!='true'){
                xhr.setRequestHeader('X-WP-Nonce', menubuilder_front_strings.wpnonce);
}  
        },
        success: function(data){
            var msg_rand = Math.floor(Math.random() * 1000000) + 1;
            if(data.status=='success'){
                from[0].reset();
                foodsearch_submit_msg_alert('alert-msg-' + msg_rand, data.msg, 'fds-alert-success');
                jQuery('#fds-emptymenu-btnsec').hide();
                jQuery('#fds-havemenu-btnsec').removeAttr('style');
                foodsearch_modal_popup_close();
                window.location.reload();
            } else {
                foodsearch_submit_msg_alert('alert-msg-' + msg_rand, data.msg, 'fds-alert-info');
            }
            _this.html(this_html);
        },
        error: function() {
            _this.html(this_html);
        }
    });
});

jQuery(document).on('click','button#menuUpdateBtn',function () {
    "use strict";
    var _this = jQuery(this);
    jQuery('button#menuUpdateBtn').prop('disabled', true);
    var from = jQuery(this).parents('form');
    var formData = from.serialize();
    jQuery('.result-status').hide();
    var this_html = _this.html();
    
    _this.html('<div class="fds-inline-loader"><div class="fds-loader"></div></div>');
    jQuery.ajax({
        type: "post",
        dataType: "json",
        url:menubuilder_front_strings.site_url + 'wp/v1/update-menu',
        data: formData,            
        beforeSend: function (xhr) {
           if(menubuilder_front_strings.adminCheck!='true'){
                xhr.setRequestHeader('X-WP-Nonce', menubuilder_front_strings.wpnonce);
}  
        },
        success: function(data){
            var msg_rand = Math.floor(Math.random() * 1000000) + 1;
            jQuery('button#menuUpdateBtn').prop('disabled', false);
            foodsearch_submit_msg_alert('alert-msg-' + msg_rand, data.msg, 'fds-alert-info');
            _this.html(this_html);
            foodsearch_modal_popup_close();
            window.location.reload();
        },
        error: function() {
            _this.html(this_html);
        }
    });
});

jQuery(document).on('click', 'button#menuItemSaveBtn',function () {
    "use strict";
    var _this = jQuery(this);
    _this.prop('disabled');
    var from = _this.parents('form');
    var formData = from.serialize();
    var this_html = _this.html();
    
    _this.html('<div class="fds-inline-loader"><div class="fds-loader"></div></div>');
    jQuery.ajax({
        type: "post",
        dataType: "json",
        url:menubuilder_front_strings.site_url + 'wp/v1/create-menu-item',
        data: formData,            
        beforeSend: function (xhr) {
           if(menubuilder_front_strings.adminCheck!='true'){
                xhr.setRequestHeader('X-WP-Nonce', menubuilder_front_strings.wpnonce);
}  
        },
        success: function(data){
            var msg_rand = Math.floor(Math.random() * 1000000) + 1;
            if(data.status=='success'){
                from[0].reset();
                foodsearch_submit_msg_alert('alert-msg-' + msg_rand, data.msg, 'fds-alert-success');
            } else {
                foodsearch_submit_msg_alert('alert-msg-' + msg_rand, data.msg, 'fds-alert-info');
            }
            
            _this.html(this_html);
        },
        error: function() {
            _this.html(this_html);
        }
    });
});

jQuery(document).on('click','button#menuItemUpdateBtn',function () {
    "use strict";
    var _this = jQuery(this);
    jQuery('button#menuItemUpdateBtn').prop('disabled', true);
    var from = jQuery(this).parents('form');
    var formData = from.serialize();
    jQuery('.result-status').hide();

    var this_html = _this.html();
    
    _this.html('<div class="fds-inline-loader"><div class="fds-loader"></div></div>');
    jQuery.ajax({
        type: "post",
        dataType: "json",
        url:menubuilder_front_strings.site_url + 'wp/v1/update-menu-item',
        data: formData,            
        beforeSend: function (xhr) {
           if(menubuilder_front_strings.adminCheck!='true'){
                xhr.setRequestHeader('X-WP-Nonce', menubuilder_front_strings.wpnonce);
}  
        },
        success: function(data){
            var msg_rand = Math.floor(Math.random() * 1000000) + 1;
            jQuery('button#menuItemUpdateBtn').prop('disabled', false);
            foodsearch_submit_msg_alert('alert-msg-' + msg_rand, data.msg, 'fds-alert-info');
            _this.html(this_html);
        },
        error: function() {
            _this.html(this_html);
        }
    });
});

jQuery(document).on('click','button#choiceGroupUpdateBtn',function () {
    "use strict";
    jQuery('button#choiceGroupUpdateBtn').prop('disabled', true);
    var from = jQuery(this).parents('form');
    var formData = from.serialize();
    jQuery('.result-status').hide();
    jQuery.ajax({
        type: "post",
        dataType: "json",
        url:menubuilder_front_strings.site_url + 'wp/v1/update-choice-group',
        data: formData,            
        beforeSend: function (xhr) {
           if(menubuilder_front_strings.adminCheck!='true'){
                xhr.setRequestHeader('X-WP-Nonce', menubuilder_front_strings.wpnonce);
}  
        },
        success: function(data){
            var msg_rand = Math.floor(Math.random() * 1000000) + 1;
            jQuery('button#choiceGroupUpdateBtn').prop('disabled', false);
            foodsearch_submit_msg_alert('alert-msg-' + msg_rand, data.msg, 'fds-alert-info');
        }
    });
});

function foodsearch_choicegroupOption() {
    "use strict";
    var maxField = 100; //Input fields increment limitation
    var wrapper = jQuery('.field_wrapper'); //Input field wrapper
    var fieldHTML = jQuery("#fooditemFiled")
        .eq(0)
        .clone()
        .find("input").val("").end().html(); //Input field wrapper
    var fieldHTMLContent = '<div class="item_box">'+fieldHTML+'</div>'; //New input field html
    var x = 1; //Initial field counter is 1

    //Once add button is clicked
    jQuery(document).on('click','.add_button', function () {
        if (x < maxField) {
            x++; //Increment field counter
            jQuery(wrapper).append(fieldHTMLContent); //Add field html
        }
        var n = jQuery(wrapper).find('div.item_box').length;
        foodsearch_updateDropdown(n);
    });

    //Once remove button is clicked
    jQuery(document).on('click', '.remove_button', function (e) {
        e.preventDefault();
        //
        jQuery(this).parents('div.item_box').remove(); //Remove field html
        x--; //Decrement field counter
        var n = jQuery(wrapper).find('div.item_box').length;
        foodsearch_updateDropdown(n);
    });
}
const foodsearch_showSidebarPopup = (function() {
    "use strict";

    return function foodsearch_showSidebarPopup(status = '',type=''){
        var boxwidth = -17;
        if(jQuery('.menu-form').hasClass('open')){
            boxwidth =-600;
        }
        jQuery('.menu-form').toggleClass('open').show();
        if(status=='update'){
            jQuery('.addform').hide();
            jQuery('.updateform').show();
            jQuery(".menu-form form.updateform").animate({
                right: boxwidth
            },'slow','linear',function(){
                //
            });
        }
        else{
            jQuery('.addform').show();
            jQuery('.updateform').hide();
            jQuery(".menu-form form.addform").animate({
                right: boxwidth
            },'slow','linear',function(){
                //
            });
        }
        if(type=='choicegroup'){
            jQuery.ajax({
                type: "post",
                dataType: "json",
                url:menubuilder_front_strings.site_url + 'wp/v1/food-choicegroup-add-form',
                data:  {
                    addin:'choiceGroupaddForm',
                },            
                beforeSend: function (xhr) {
                   if(menubuilder_front_strings.adminCheck!='true'){
                xhr.setRequestHeader('X-WP-Nonce', menubuilder_front_strings.wpnonce);
}  
                },
                success: function(data){
                    jQuery('span.spin').hide();
                    jQuery('.filed-group-con').html(data.html);
                    foodsearch_choicegroupOption();
                    foodsearch_initailizeSelect2();
                    foodsearch_restaurantdropdown();
                    jQuery('.filed-group-con').show();

                }
            });
        }
        else if(type=='menus'){
            jQuery.ajax({
                type: "post",
                dataType: "json",
                url:menubuilder_front_strings.site_url + 'wp/v1/food-menus-add-form',
                data:  {
                    addin:'menusaddForm',
                },            
                beforeSend: function (xhr) {
                   if(menubuilder_front_strings.adminCheck!='true'){
                xhr.setRequestHeader('X-WP-Nonce', menubuilder_front_strings.wpnonce);
}  
                },
                
                success: function(data){
                    jQuery('span.spin').hide();
                    jQuery('.filed-group-con').html(data.html);
                    foodsearch_restaurantdropdown();
                    foodsearch_selectdropdownFiled();
                    jQuery('.filed-group-con').show();

                }
            });
        }
        else if(type=='menuitems'){
            jQuery.ajax({
                type: "post",
                dataType: "json",
                url:menubuilder_front_strings.site_url + 'wp/v1/food-menuitm-add-form',
                data:  {
                    addin:'menusItemaddForm',
                },            
                beforeSend: function (xhr) {
                   if(menubuilder_front_strings.adminCheck!='true'){
                xhr.setRequestHeader('X-WP-Nonce', menubuilder_front_strings.wpnonce);
}  
                },
                success: function(data){
                    jQuery('span.spin').hide();
                    jQuery('.filed-group-con').html(data.html);
                    foodsearch_itemcategoriesinitailize();
                    foodsearch_selectdropdownFiled();
                    foodsearch_choiceGroupdropdown();
                   foodsearch_extendVariationFileds();
                    foodsearch_menudropdown();
                    jQuery('.filed-group-con').show();

                }
            });
        }


    }
})();
function foodsearch_itemcategoriesinitailize(){
    "use strict";
    jQuery('.food-item-category-dropdown').select2({
        width: '100%',
        ajax: {
            url: menubuilder_front_strings.site_url + 'wp/v1/itemcategories',            
            beforeSend: function (xhr) {
               if(menubuilder_front_strings.adminCheck!='true'){
                xhr.setRequestHeader('X-WP-Nonce', menubuilder_front_strings.wpnonce);
}  
            },
            dataType: 'json'
        }
    });
}
function foodsearch_updateDropdown(n){
    "use strict";
    foodsearch_initailizeSelect2();
    var maxContent = '', minContent = '';
    for(var i =0;i<=n;i++){
        minContent +='<option value="'+i+'">'+i+'</option>';
    }
    jQuery('.min_dropdown').html(minContent);

    for(var i =1;i<=n;i++){
        maxContent +='<option value="'+i+'">'+i+'</option>';
    }
    jQuery('.max_dropdown').html(maxContent);
}

const foodsearch_initailizeSelect2 = (function() {
    "use strict";
    return function foodsearch_initailizeSelect2(restaurant_id = 0) {

        jQuery('.food-item-dropdown').select2({
            width: '100%',
            ajax: {
                url: menubuilder_front_strings.site_url + 'wp/v1/fooditems',
                dataType: 'json',            
                beforeSend: function (xhr) {
                   if(menubuilder_front_strings.adminCheck!='true'){
                xhr.setRequestHeader('X-WP-Nonce', menubuilder_front_strings.wpnonce);
}  
                },
                data: function (params) {
                    var query = {
                        restaurant: restaurant_id,
                        q: params.term
                    }
                    return query;
                },
            }
        });
    }
})();
function foodsearch_selectdropdownFiled() {
    "use strict";
    jQuery('.select_dropdown').select2({
        width: '100%',
    });
}
function foodsearch_restaurantdropdown(){
    "use strict";
    jQuery('.restaurant-dropdown').select2({
        width: '100%',
        ajax: {
            url: menubuilder_front_strings.site_url + 'wp/v1/restaurantDropdown',            
            beforeSend: function (xhr) {
               if(menubuilder_front_strings.adminCheck!='true'){
                xhr.setRequestHeader('X-WP-Nonce', menubuilder_front_strings.wpnonce);
}  
            },
            dataType: 'json'
        }
    });
}
const foodsearch_choiceGroupdropdown = (function() {
    "use strict";
    return function foodsearch_choiceGroupdropdown(restaurant_id = 0) {
        jQuery('.food-item-choicegroup-dropdown').select2({
            width: '100%',
            ajax: {
                url: menubuilder_front_strings.site_url + 'wp/v1/choicegroupList',            
                beforeSend: function (xhr) {
                   if(menubuilder_front_strings.adminCheck!='true'){
                xhr.setRequestHeader('X-WP-Nonce', menubuilder_front_strings.wpnonce);
}  
                },
                dataType: 'json',
                data: function (params) {
                    var query = {
                        restaurant: restaurant_id,
                        q: params.term
                    }
                    return query;
                },
            }
        });
    }
})();
function foodsearch_extendVariationFileds(){
    "use strict";
    var x = 1; //Initial field counter is 1
    var wrapperV = jQuery('.variation_wrapper_outer'); //Input field wrapper
    jQuery(document).on('click','.add_variation_button', function () {
        x++; //Increment field counter
        jQuery('.price_wrap').hide();
        jQuery('.variation_wrapper_outer').show();
        jQuery(".item_box")
            .eq(0)
            .clone()
            .find("input").val("").end() // ***
            .show()
            .insertAfter(".item_box:last");
        var n = jQuery(wrapperV).find('div.item_box').length;
    });

    //Once remove button is clicked
    jQuery(document).on('click', 'a.remove_variation_button', function (e) {
        e.preventDefault();
        jQuery(this).parents('div.item_box').remove(); //Remove field html
        x--; //Decrement field counter
        var n = jQuery(wrapperV).find('div.item_box').length;
        if (n == 1) {
            jQuery('.price_wrap').show();
            jQuery('.variation_wrapper_outer').hide();
        }
    });
}
function foodsearch_menudropdown(){
    "use strict";
    jQuery('.food-menu-dropdown').select2({
        width: '100%',
        ajax: {
            url: menubuilder_front_strings.site_url + 'wp/v1/menuList',            
            beforeSend: function (xhr) {
               if(menubuilder_front_strings.adminCheck!='true'){
                xhr.setRequestHeader('X-WP-Nonce', menubuilder_front_strings.wpnonce);
}  
            },
            dataType: 'json'
            // Additional AJAX parameters go here; see the end of this chapter for the full code of this example
        }
    });
}