// const { on } = require("events");

jQuery(document).on('click','input#cartCheckBtn',function(ev){
    "use strict";
    ev.preventDefault();
    
    var _this = jQuery(this);
    _this.parent('div.fds-btn').append('<div class="fds-loader-holder"><div class="fds-loader"></div></div>');
    var msg_rand = Math.floor(Math.random() * 1000000) + 1;
    jQuery.ajax({
        type: "get",
        dataType: 'json',
        url: foodsearch_common_vars.site_url + 'wp/v1/restaurants-delivery-check',                
        success: function(res){                   
            if(res==true){                  
                _this.parents('form').submit();
            }
            else{
                _this.parent('div.fds-btn').find('.fds-loader-holder').remove();
                foodsearch_submit_msg_alert('alert-msg-' + msg_rand, 'This resturent is not deliverd to you addredd', 'fds-alert-danger');
            }
        }
    });
});
jQuery(document).on('submit', '.fds-userorder-cart-form', function (ev) {
    "use strict";
    ev.preventDefault();
    
    var _this = jQuery(this),
    from_element = _this[0],
    form_data = new FormData(from_element);
    
    _this.append('<div class="fds-loader-holder"><div class="fds-loader"></div></div>');

    jQuery.ajax({
        type: "post",
        dataType: "json",
        url: foodsearch_common_vars.site_url + 'wp/v1/user-ordercart-submit-act',
        processData: false,
        contentType: false,
        data: form_data,
        success: function(data) {           
            window.location.href = data.url;
        },        
        beforeSend: function (xhr) {
            if(foodsearch_common_vars.adminCheck!='true'){
                xhr.setRequestHeader('X-WP-Nonce', foodsearch_common_vars.wpnonce);
}  
        },
        error: function() {
            _this.find('.fds-loader-holder').remove();
        }
    });
});
jQuery(document).on('submit', '.fds-wc-userorder-cart-form', function (ev) {
    "use strict";
    ev.preventDefault();
    
    var _this = jQuery(this),
    from_element = _this[0],
    form_data = new FormData(from_element);
    
    _this.append('<div class="fds-loader-holder"><div class="fds-loader"></div></div>');
    form_data.append('action', 'wc_add_to_cart');
    form_data.append('nonce', myAjax.nonce);
    jQuery.ajax({
        url : myAjax.url,
        processData: false,
        contentType: false,
        data:form_data ,
        type : "POST",
        success : function(data) {
            window.location.href = data.url;
        },
        error : function() {
            _this.find('.fds-loader-holder').remove();
        }
    });    
});

jQuery(document).on('submit', '#fds-order-checkout-form', function (ev) {
    "use strict";
    ev.preventDefault();
    
    var _this = jQuery(this),
    from_element = _this[0],
    form_data = new FormData(from_element),
    this_loder = _this.find('.fds-loader-holder');
    
    this_loder.html('<div class="fds-loader"></div>').removeAttr('style');

    var request = jQuery.ajax({
        method: "POST",
        dataType: "json",
        url: foodsearch_common_vars.site_url + 'wp/v1/user-order-checkout-submit',
        processData: false,
        contentType: false,
        data: form_data,
        beforeSend: function (xhr) {
            if(foodsearch_common_vars.adminCheck!='true'){
                xhr.setRequestHeader('X-WP-Nonce', foodsearch_common_vars.wpnonce);
}  
        },
    });
    request.done(function (response) {

        var msg_rand = Math.floor(Math.random() * 1000000) + 1;
        if (response.error == '0') {
            foodsearch_submit_msg_alert('alert-msg-' + msg_rand, response.msg, 'fds-alert-success');
            window.location.href = response.redirect;
        } else {
            foodsearch_submit_msg_alert('alert-msg-' + msg_rand, response.msg, 'fds-alert-danger');
        }
    });
    request.always(function () {
        this_loder.html('').hide();
    });

    return false;
});