<?php
function admin_funcitons(){
    add_action( 'admin_notices', 'wpb_admin_notice_warn' );        
    add_action('wp_ajax_nopriv_update_location_db',  'update_location_db');
    add_action('wp_ajax_update_location_db','update_location_db');
}
add_action('admin_init', 'admin_funcitons');
 

function update_location_db()
    {
        global $wpdb, $table_prefix;
        $tblname = 'fds_locations';
        $wp_track_table = $table_prefix . "$tblname";
        $row = $wpdb->get_results(  "SELECT COLUMN_NAME FROM INFORMATION_SCHEMA.COLUMNS
                WHERE table_name = $wp_track_table AND column_name = 'city' AND column_name = 'state' AND column_name = 'country' AND column_name = 'zipcode'"  );
       if(empty($row)){
            $sql = "ALTER TABLE `{$wp_track_table}` ADD `city` VARCHAR(150) NULL AFTER `lng`, ADD `state` VARCHAR(150) NULL AFTER `city`, ADD `country` VARCHAR(150) NULL AFTER `state`, ADD `zip_code` VARCHAR(20) NULL AFTER `country`, ADD `post_type` VARCHAR(20)  NULL DEFAULT 'restaurants' AFTER `post_id`, ADD INDEX `post_type` (`post_type`(20));";
            $wpdb->query($sql);
            add_option( 'fds_location_table_updated', 'yes', '', 'yes' );

        }
    }    
     function wpb_admin_notice_warn() {
        if (get_option('fds_location_table_updated') != 'yes') {
            echo '<div class="notice notice-warning is-dismissible">
              <p><a href="#" id="update-location-table">Click Here</a>  to update location table, Please take DB backup before clicking this button.  </p>
              </div>';
        }
    }