<?php

class foodsearch_dashboard {

    public function __construct() {
        $this->includes();
        add_action('wp_enqueue_scripts', [$this, 'register_frontend_script']);
       
    }

    public function includes() {
        include plugin_dir_path(dirname(__FILE__)) . 'dashboard/common.php';
        include plugin_dir_path(dirname(__FILE__)) . 'dashboard/shortcode.php';
        include plugin_dir_path(dirname(__FILE__)) . 'dashboard/rest-api.php';
        include plugin_dir_path(dirname(__FILE__)) . 'dashboard/submit.php';
        include plugin_dir_path(dirname(__FILE__)) . 'dashboard/content/dashboard.php';
    }

    public function register_frontend_script() {
        wp_register_script('jquery-datetimepicker', foodsearch_plugin_get_url('assets/script/jquery.datetimepicker.full.min.js', __FILE__), array('jquery'));
        wp_enqueue_script('functions', foodsearch_plugin_get_url('assets/script/functions.js', __FILE__), array('jquery'));
        wp_localize_script('functions', 'myAjax', array('url' => admin_url('admin-ajax.php'), 'nonce' => wp_create_nonce('ajax-nonce')));
    }

   

}

new foodsearch_dashboard();
