
<form id="frm_restaurant_listing">
  <input type="hidden" name="filter_counts" value="<?php echo $attr["filter_counts"]; ?>">
  <input type="hidden" name="see_more" value="<?php echo $attr["see_more_counts"]; ?>">
  <input type="hidden" name="page_id" value="<?php the_id() ?>">
  <input type="hidden" name="u_id" value="<?php echo get_current_user_id(); ?>">
  <input type="hidden" id="pagination" value="<?php echo $attr['pagination']?>">

<div class="fds-main-content" id="fds-block-<?php echo $attr["blockId"]; ?>">
  <?php echo foodsearch_search_field_html(); ?>
  <div class="fds-mobile-filter-wrap">
    <a class="fds-link fds-res-filter-btn"><i class="fds-icon fds-filter"></i></a>
      
    <div class="fds-res-filterable">
      <div class="fds-res-dropdown">
        <div class="fds-res-dropdown-up">
          <span><?php esc_html_e('sort by:', 'wp-foodsearch') ?></span>
          <i class="fds-icon fds-down-arrow"></i>
        </div>
        <div class="fds-res-dropdown-sub">
          <ul class="fds-options-wrap fds-sorting-options-list order_by">
              <?php if ( !isset($attr['highest_rated']) || $attr['highest_rated'] === true ){ ?>
                  <li class="fds-list-item">
                    <input type="radio" name="order_by" value="rating" <?= isset($_GET['order']) && $_GET['order'] == "rating" ? 'checked="checked"' : ''; ?> />
                    <label class="fds-radio-style"><i class="fds-icon fds-star1"></i> <?php esc_html_e('highest rated', 'wp-foodsearch') ?></label>
                  </li>
              <?php } ?>
              <?php if ( !isset($attr['most_reviewed']) || $attr['most_reviewed'] === true ){ ?>
                  <li class="fds-list-item">
                    <input type="radio" name="order_by" value="reviews" <?= isset($_GET['order']) && $_GET['order'] == "reviews" ? 'checked="checked"' : ''; ?> />
                    <label class="fds-radio-style"><i class="fds-icon fds-edit"></i> <?php esc_html_e('most reviewed', 'wp-foodsearch') ?></label>
                  </li>
              <?php } ?>

              <li class="fds-list-item clear-all" style="<?php echo ($_SERVER['QUERY_STRING']) ? '' : 'display:none'; ?>">
                  <i class="fds-icon fds-time-simple"></i>
                  <a href="<?php the_permalink(); ?>" class="fds-link fds-has-bg"><?php esc_html_e('clear all', 'wp-foodsearch') ?></a>
              </li>
          </ul>
        </div>
      </div>
      <div class="fds-res-view-btn">
        <a href="#" class="fds-link"><i class="fds-icon fds-list"></i></a>
        <a href="#" class="fds-link"><i class="fds-icon fds-menu"></i></a>
      </div>
    </div>
  </div>
    <!--// Main Section //-->
    <div class="fds-main-section fds-typo-wrap">
            <div class="fds-listing-con">

                <?php if ( !isset($attr['location_se']) || $attr['filter_options'] === true ){ ?>
                <!--// SideBaar //-->
                    <div class="fds-filter-sidebar">
                  
                    <?php
                    global $foodsearch_plugin_settings;
                    if ($foodsearch_plugin_settings['location_settings']['disply_res'] == 'on') { ?>
                    <!--// Widget Filter Link //-->
                    <div class="plugin-filter fds-location-block-wrap" <?=!isset($_SESSION['customer_location']) ? 'style="display:none;"' : ''; ?>>
                      <div class="plugin-filter-wrap">
                      <span class="fds-addrs-icon">  
                      <i class="fds-icon fds-pin-line"></i>
                      </span>

                          <div class="fds-address-wrap fds-addres-change" <?= isset($_SESSION['customer_location']) ? 'data-lat="' . $_SESSION['customer_location']['lat'] . '" data-lng="' . $_SESSION['customer_location']['lng'] . '"' : '' ?>>
                              <span class="fds-address-item " id="fds-address-block" >
                              <?php if (isset($_SESSION['customer_location'])) { ?>
                                  <?php echo $_SESSION['customer_location']['address']; ?>
                                  <?php } ?>
                              </span>
                              <span class="fds-address-item  fds-edit-loc"> 
<span id="fds-order-type-block">
                            <?php if ( isset($_SESSION['customer_location'])){ ?>                             
                            <?php esc_html_e($_SESSION['customer_location']['order_type'], 'wp-foodsearch') ?>
                            <?php  }?>
                            
                            </span> <i class="fds-icon fds-edit"></i></span>
                              
                    </div>
                      </div>
                  </div>
                  <!--// Widget Filter Link //-->
                  <?php
                    }
                 
                      if ( !isset($attr['filter_by']) || $attr['filter_by'] === true ){ ?>
                    
                      <!--// Widget Filter Link //-->
                      <div class="plugin-filter fds-filter-radio">
                        <div class="plugin-filter-wrap">
                            <span class="plugin-filter-title"><?php esc_html_e('order by', 'wp-foodsearch') ?></span>
                            <ul class="fds-options-wrap order_by">
                                <li class="fds-list-item">
                                    <input type="radio" name="order" value="best-match" <?= isset($_GET['order']) && $_GET['order'] == "best-match" ? 'checked="checked"' : ''; ?> />
                                    <label class="fds-radio-style"><i class="fds-icon fds-hand-thumb-line"></i> <?php esc_html_e('best match', 'wp-foodsearch') ?></label>
                                </li>
                                <li class="fds-list-item">
                                    <input type="radio" name="order" value="title" <?= isset($_GET['order']) && $_GET['order'] == "title" ? 'checked="checked"' : ''; ?> />
                                    <label class="fds-radio-style"><i class="fds-icon fds-alphabetical"></i> <?php esc_html_e('alphabetical', 'wp-foodsearch') ?></label>
                                </li>
                                <li class="fds-list-item">
                                    <input type="radio" name="order" value="rating" <?= isset($_GET['order']) && $_GET['order'] == "rating" ? 'checked="checked"' : ''; ?> />
                                    <label class="fds-radio-style"><i class="fds-icon fds-star-line"></i> <?php esc_html_e('ratings', 'wp-foodsearch') ?></label>
                                </li>
                                <li class="fds-list-item">
                                    <input type="radio" name="order" value="minimum-order" <?= isset($_GET['order']) && $_GET['order'] == "minimum-order" ? 'checked="checked"' : ''; ?> />
                                    <label class="fds-radio-style"><i class="fds-icon fds-hotel"></i> <?php esc_html_e('minimum order value', 'wp-foodsearch') ?></label>
                                </li>
                                <li class="fds-list-item">
                                    <input type="radio" name="order" value="minimum-delivery-fee" <?= isset($_GET['order']) && $_GET['order'] == "minimum-delivery-fee" ? 'checked="checked"' : ''; ?> />
                                    <label class="fds-radio-style"><i class="fds-icon fds-dollar-coin-circle"></i> <?php esc_html_e('minimum delivery fee', 'wp-foodsearch') ?></label>
                                </li>
                                <li class="fds-list-item">
                                    <input type="radio" name="order" value="fastest-delivery" <?= isset($_GET['order']) && $_GET['order'] == "fastest-delivery" ? 'checked="checked"' : ''; ?> />
                                    <label class="fds-radio-style"><i class="fds-icon fds-courier-bus"></i> <?php esc_html_e('fastest delivery', 'wp-foodsearch') ?></label>
                                </li>
                            </ul>
                        </div>
                    </div>
                    <!--// Widget Filter Link //-->
                    <?php 
                    }
                    if ( !isset($attr['cuisine_type']) || $attr['cuisine_type'] === true ){
                    ?>

                        <!--// Widget Filter Radio //-->
                        <div class="plugin-filter fds-filter-radio">
                            <div class="plugin-filter-wrap">
                                <span class="plugin-filter-title"><?php esc_html_e('cuisine type', 'wp-foodsearch') ?></span>
                                <ul class="fds-options-wrap cuisine-type">
                                  <?php
                                    $terms = get_terms( array(
                                      'taxonomy' => 'food_cuisine',
                                      'orderby'   => 'count',
                                      'order' => 'DESC',
                                    ) );
                                    $counter = 0;
                                    $arr = array();
                                    if ( isset($_GET['cuisine']) && !is_array($_GET['cuisine']) ) {
                                      $arr = (array) explode (",", $_GET['cuisine']);
                                    }
                                    else if ( isset($_GET['cuisine'])) {
                                      $arr = $_GET['cuisine'];
                                    }
                                      foreach ($terms as $term){
                                          $counter++;
                                          $cuisine_type_checked = "";
                                          if ( isset($_GET['cuisine']) && in_array($term->slug, $arr) ) {
                                              $cuisine_type_checked = 'checked="checked"';
                                          }
                                      ?>
                                          <li class="fds-list-item sb_cuisine <?php echo ($counter > $attr["see_more_counts"] ) ? "cuisine-toggle" : ""; ?>" >
                                              <input type="checkbox" name="cuisine[]" id="<?php echo $term->term_id; ?>" value="<?php echo $term->slug; ?>" <?php echo $cuisine_type_checked; ?> />
                                              <label class="fds-radio-style fds-radio-square"><?php echo $term->name; ?></label>
                                              <?php if ( !isset($attr['filter_counts']) || $attr['filter_counts'] === true ){ ?>
                                                <small id="sb_cuisine<?php echo $term->term_id; ?>">0</small>
                                              <?php } ?>
                                          </li>
                                  <?php } ?>
                                </ul>
                                <?php if ( count($terms) > $attr["see_more_counts"] ) { ?>
                                  <a href="javascript:void(0)" id="cuisine-toggle" class="fds-link fds-see-more">See More</a>
                                <?php } ?>
                            </div>
                        </div>
                        <!--// Widget Filter Radio //-->

                    <?php 
                    }
                    if ( !isset($attr['options']) || $attr['options'] === true ){ 
                    ?>

                    <!--// Widget Filter Radio //-->
                    <div class="plugin-filter fds-filter-radio">
                        <div class="plugin-filter-wrap">
                            <span class="plugin-filter-title"><?php esc_html_e('options', 'wp-foodsearch') ?></span>
                            <ul class="fds-options-wrap options">
                              <li class="fds-list-item">
                                <input type="checkbox" name="delivery" value="1" <?= isset($_GET['delivery']) && $_GET['delivery'] == 1 ? 'checked="checked"' : ''; ?> >
                                <label class="fds-radio-style fds-radio-square"><?php esc_html_e('delivery', 'wp-foodsearch') ?></label>
                                <?php if ( !isset($attr['filter_counts']) || $attr['filter_counts'] === true ){ ?>
                                  <small id="sb_delivery">0</small>
                                <?php } ?>
                              </li>
                              <li class="fds-list-item">
                                <input type="checkbox" name="take_away" value="1" <?= isset($_GET['take_away']) && $_GET['take_away'] == 1 ? 'checked="checked"' : ''; ?> >
                                <label class="fds-radio-style fds-radio-square"><?php esc_html_e('take away', 'wp-foodsearch') ?></label>
                                <?php if ( !isset($attr['filter_counts']) || $attr['filter_counts'] === true ){ ?>
                                  <small id="sb_take_away">0</small>
                                <?php } ?>
                              </li>

                            </ul>
                        </div>
                    </div>
                    <!--// Widget Filter Radio //-->

                    <?php 
                    }
                    if ( !isset($attr['rating']) || $attr['rating'] === true ){ 
                    ?>

                    <!--// Widget Filter Rating //-->
                    <div class="plugin-filter fds-filter-rating">
                        <div class="plugin-filter-wrap">
                            <span class="plugin-filter-title"><?php esc_html_e('ratings', 'wp-foodsearch') ?></span>
                            <ul class="fds-options-wrap rating-area">
                              <li class="fds-list-item">
                                  <div class="fds-filter-radio">
                                      <input type="radio" name="ratings" value="5" <?php if ( isset($_GET['ratings']) && $_GET['ratings'] == 5) echo "checked"; ?> />
                                      <label class="fds-radio-style">
                                          <div class="fds-rating-stars">
                                              <span class="fds-rating-stars-fill" style="width: 100%" ></span>
                                          </div>
                                      </label>
                                  </div>
                                  <?php if ( !isset($attr['filter_counts']) || $attr['filter_counts'] === true ){ ?>
                                    <small class="fds-filter-rating-subtitle" id="sb_rating5">0</small>
                                  <?php } ?>
                              </li>
                              <li class="fds-list-item">
                                  <div class="fds-filter-radio">
                                      <input type="radio" name="ratings" value="4" <?php if ( isset($_GET['ratings']) && $_GET['ratings'] == 4) echo "checked"; ?> />
                                      <label class="fds-radio-style">
                                          <div class="fds-rating-stars">
                                              <span class="fds-rating-stars-fill" style="width: 80%" ></span>
                                          </div>
                                      </label>
                                  </div>
                                  <?php if ( !isset($attr['filter_counts']) || $attr['filter_counts'] === true ){ ?>
                                    <small class="fds-filter-rating-subtitle" id="sb_rating4">0</small>
                                  <?php } ?>
                              </li>
                              <li class="fds-list-item">
                                  <div class="fds-filter-radio">
                                      <input type="radio" name="ratings" value="3" <?php if ( isset($_GET['ratings']) && $_GET['ratings'] == 3) echo "checked"; ?> />
                                      <label class="fds-radio-style">
                                          <div class="fds-rating-stars">
                                              <span class="fds-rating-stars-fill" style="width: 60%" ></span>
                                          </div>
                                      </label>
                                  </div>
                                  <?php if ( !isset($attr['filter_counts']) || $attr['filter_counts'] === true ){ ?>
                                    <small class="fds-filter-rating-subtitle" id="sb_rating3">0</small>
                                  <?php } ?>
                              </li>
                              <li class="fds-list-item">
                                  <div class="fds-filter-radio">
                                      <input type="radio" name="ratings" value="2" <?php if ( isset($_GET['ratings']) && $_GET['ratings'] == 2) echo "checked"; ?> />
                                      <label class="fds-radio-style">
                                          <div class="fds-rating-stars">
                                              <span class="fds-rating-stars-fill" style="width: 40%" ></span>
                                          </div>
                                      </label>
                                  </div>
                                  <?php if ( !isset($attr['filter_counts']) || $attr['filter_counts'] === true ){ ?>
                                    <small class="fds-filter-rating-subtitle" id="sb_rating2">0</small>
                                  <?php } ?>
                              </li>
                            </ul>
                        </div>
                    </div>
                    <!--// Widget Filter Rating //-->
                    <?php } ?>

                </div>
                <!--// SideBaar //-->
                <?php } ?>

                <!--// Content Section //-->
                <div class="fds-listings-wrap">

                    <?php if ( !isset($attr['sort_options']) || $attr['sort_options'] === true ){ ?>
                    <!--// Sorting Options //-->
                    <div class="fds-sorting-options">
                        <div class="fds-sorting-option fds-filter-radio">
                            <span class="fds-sorting-bytitle"><?php esc_html_e('sort by:', 'wp-foodsearch') ?></span>
                            <ul class="fds-options-wrap fds-sorting-options-list order_by">
                                <?php if ( !isset($attr['highest_rated']) || $attr['highest_rated'] === true ){ ?>
                                    <li class="fds-list-item">
                                      <input type="radio" name="order_by" value="rating" <?= isset($_GET['order']) && $_GET['order'] == "rating" ? 'checked="checked"' : ''; ?> />
                                      <label class="fds-radio-style"><i class="fds-icon fds-star1"></i> <?php esc_html_e('highest rated', 'wp-foodsearch') ?></label>
                                    </li>
                                <?php } ?>
                                <?php if ( !isset($attr['most_reviewed']) || $attr['most_reviewed'] === true ){ ?>
                                    <li class="fds-list-item">
                                      <input type="radio" name="order_by" value="reviews" <?= isset($_GET['order']) && $_GET['order'] == "reviews" ? 'checked="checked"' : ''; ?> />
                                      <label class="fds-radio-style"><i class="fds-icon fds-edit"></i> <?php esc_html_e('most reviewed', 'wp-foodsearch') ?></label>
                                    </li>
                                <?php } ?>
                                <?php if ( !isset($attr['near_me']) || $attr['near_me'] === true ){ ?>
                                    <li class="fds-list-item">
                                      <input type="radio" name="order_by" value="near_me" <?= isset($_GET['order']) && $_GET['order'] == "near_me" ? 'checked="checked"' : ''; ?> />
                                      <label class="fds-radio-style"><i class="fds-icon fds-pin-line"></i> <?php esc_html_e('near me', 'wp-foodsearch') ?></label>
                                    </li>
                                <?php } ?>

                                <li class="fds-list-item clear-all" style="<?php echo ($_SERVER['QUERY_STRING']) ? '' : 'display:none'; ?>">
                                    <a href="<?php the_permalink(); ?>" class="fds-link fds-has-bg"><i class="fds-icon fds-time-simple"></i><?php esc_html_e('clear all', 'wp-foodsearch') ?></a>
                                </li>
                            </ul>
                        </div>

                        <?php if ( !isset($attr['grid_list']) || $attr['grid_list'] === true ){
                            $grid_active = '';
                            $list_active = '';
                            $view_mod = "grid";
                            if ( isset($attr['view_mod']) ) $view_mod = $attr['view_mod'];
                            if ( isset($_GET['style']) ) $view_mod = $_GET['style'];
                            if ( $view_mod === "grid" ) {
                                $grid_active = "active";
                            }
                            else {
                                $list_active = "active";
                            }
                        ?>
                            <div class="fds-style-switch">
                                <input type="hidden" name="style" value="<?php echo $view_mod; ?>">
                                <ul class="fds-options-wrap fds-sorting-options-views">
                                    <li class="fds-list-item <?php echo $list_active; ?>"><a class="fds-link fds-icon fds-list"></a></li>
                                    <li class="fds-list-item <?php echo $grid_active; ?>"><a class="fds-link fds-icon fds-menu"></a></li>
                                </ul>
                            </div>
                        <?php } ?>
                    </div>
                    <!--// Sorting Options //-->
                    <?php } ?>

                    <!--// Restaurants Listing's //-->
                    <div class="fds-restaurants" id="restaurant_area">
                      <?php                       
                      global $foodsearch_plugin_settings;
                      //echo '<pre>'.print_r($foodsearch_plugin_settings,true).'</pre>';
                      require_once 'location_popup.php';
                      if ((isset($_SESSION['customer_location']) && $foodsearch_plugin_settings['location_settings']['disply_res'] == 'on') 
                      || (isset($_SESSION['customer_location']) && $foodsearch_plugin_settings['location_settings']['disply_res'] != 'on')
                      || (!isset($_SESSION['customer_location']) && $foodsearch_plugin_settings['location_settings']['disply_res'] != 'on')
                       ) {
                       
                        require_once 'restaurant_listing.php';
                       
                      }
                      ?>
                    </div>
                    <!--// Restaurants Listing's //-->
                    <div class="loaderBlock">
                    <?php
                    if (!isset($listing['total'])) {
                      $listing['total'] = 11;
                    }
                      if ($attr['pagination'] == "on_click" && $attr['number_of_items'] < $listing['total']) { ?>
                        <div class='fds-btn fds-medium-btn'>
                          <a class='load_more loader-load-more fds-has-bg'><?php esc_html_e('load more', 'wp-foodsearch') ?></a>
                        </div>
                    <?php
                      } else if ($attr['pagination'] == "on_scroll" && $attr['number_of_items'] < $listing['total']) {
                    ?>
                        <div class="loader-on-scroll"><div class="fds-inline-loader"><div class="fds-loader"></div></div></div>
                    <?php }
                      

                  //  }
                    ?>
                    </div>

                </div>
                <!--// Content Section //-->

        </div>
    </div>
    <!--// Main Section //-->

</div>
</form>

