
<?php
$u_id = isset( $_GET['u_id'] ) ? $_GET['u_id'] : 0 ;
use FoodSearch\User_Reviews;
use FoodSearch\Common_Functions;
global $post,$foodsearch_plugin_settings;
//echo '<pre>'.print_r($foodsearch_plugin_settings,true).'</pre>';

if ( empty($attr) ){
  $post = get_post($_GET['page_id']);
  if ( has_blocks( $post->post_content ) ) {
    $blocks = parse_blocks( $post->post_content );
    foreach ($blocks as $block) {
      if ( $block['blockName'] === 'foodsearch/restaurants' ) {
        $attr = $block["attrs"] ;
        if ( !isset($attr['order_by']) ) $attr['order_by'] = "desc";
        if ( !isset($attr['number_of_column']) ) $attr['number_of_column'] = 2;
        if ( !isset($attr['number_of_items']) ) $attr['number_of_items'] = 10;
        if ( !isset($attr['show_image']) ) $attr['show_image'] = true;
        if ( !isset($attr['show_favourite']) ) $attr['show_favourite'] = true;
        if ( !isset($attr['show_title']) ) $attr['show_title'] = true;
        if ( !isset($attr['show_reviews']) ) $attr['show_reviews'] = true;
        if ( !isset($attr['show_distance']) ) $attr['show_distance'] = true;
        if ( !isset($attr['show_delFee']) ) $attr['show_delFee'] = true;
        if ( !isset($attr['show_timing']) ) $attr['show_timing'] = true;
        if ( !isset($attr['show_menuBTN']) ) $attr['show_menuBTN'] = true;
        if ( !isset($attr['records_count']) ) $attr['records_count'] = 1;
        if ( !isset($attr['pagination']) ) $attr['pagination'] = "on_scroll";
      }
    }
  }
}

if ( isset($attr['pagination']) && $attr['pagination'] == "numbers" ) {
  
  $current_page = get_query_var('page');
  if ( empty($current_page) ){    
    $current_page = get_query_var('paged');
  }
  if ( (int)$current_page == 0){    
  
    $current_page = 1;
  } 
  $_GET['offset'] = ( $current_page - 1) * $attr['number_of_items']  ;
}
// echo '<pre>'.$current_page.': '.print_r( $attr,true).'</pre>';
// exit();
if ( !isset ( $_GET['offset'] ) ) $_GET['offset'] = 0;
$listing = foodsearch_listing($_GET['offset'], $attr['number_of_items'] );

if ( !isset($_SESSION) ) session_start();
$_SESSION['post_ids'] = $listing['posts'];

  if (isset( $attr['records_count'] ) && ($attr['records_count'] == 1) && (!$_GET['offset'] || $attr['pagination'] == "numbers") ) {
    echo "<div class='fds-found-record-wrap'><span class='fds-total-record'>" . $listing['total'] . esc_html__(' Restaurants Found', 'wp-foodsearch') .  "</span>";
    if ( $listing['total'] > 0 ) echo "<span class='fds-displayed-here'>" . esc_html__('Displayed Here:', 'wp-foodsearch') . "&nbsp;" . ($_GET['offset'] + 1) . "&nbsp;-&nbsp;<span class='offset'>" . ($_GET['offset'] + $attr['number_of_items']) . "</span>&nbsp;" . esc_html__('Restaurants', 'wp-foodsearch') . "</span>";
    echo "</div>";
  }

  if ( $listing['total'] == 0 ) {
  ?>
    <div class="fds-sory-box">
      <img src="<?php echo plugins_url()?>/wp-foodsearch/assets/images/not-found.svg" />
      <span class="fds-list-not-found"><?php esc_html_e('sorry', 'wp-foodsearch') ?></span>
      <strong class="fds-not-found-msg"><?php esc_html_e('no restaurants match the selected criteria', 'wp-foodsearch') ?></strong>
    </div>
  <?php
  }

    ?>
      <div class="fds-listing-item-wrap">
    <?php
        $view_mod = "grid";
        if ( isset($attr['view_mod']) ) $view_mod = $attr['view_mod'];
        if ( isset($_GET['style']) ) $view_mod = $_GET['style'];
        if ( $view_mod === "grid" ) {
          ?>
            <!--// Grid View //-->
                    <?php
                    if ( $listing['posts'] ) {
                      foreach ( $listing['posts'] as $post ) {
                        $cats = get_the_terms(get_the_id(), "food_item_cat");
                        $restaurant_avg_rating = User_Reviews::restaurant_avg_review_rate(get_the_id());
                        ?>

                            <div class="fds-grid-item fds-col-<?php echo $attr['number_of_column']; ?>">
                                <div class="fds-restaurant-grid-wrap">
                                  <?php if ( $attr['show_image'] ) { ?>
                                    <div class="fds-item-thumb">
                                        <?php
                                        $bg = get_the_post_thumbnail_url();
                                        if ( empty($bg) ) $bg = plugin_dir_url(__FILE__)."../images/no-image.jpg";
                                        ?>
                                        <a href="<?php the_permalink($post->ID); ?>" class="fds-link fds-restaurant-grid-thumb"><img src="<?php echo $bg ?>" alt="<?php echo get_the_title($post->ID); ?>"></a>
                                        <?php
                                        if ( $attr['show_favourite'] ) {
                                          Common_Functions::restaurant_fav_btn_html(get_the_id(), 'list', $u_id );
                                        }
                                        ?>
                                    </div>
                                  <?php } ?>
                                  
                                    <div class="fds-restaurant-grid-text">
                                        <?php if ( $attr['show_title'] ) { ?>
                                          <h2 class="fds-ps-title fds-post-title"><a class="fds-link" href="<?php the_permalink($post->ID); ?>"><?php echo get_the_title($post->ID); ?></a></h2>
                                        <?php
                                        }
                                        if ( isset($attr['show_reviews']) && $attr['show_reviews'] && isset($restaurant_avg_rating['count']) && $restaurant_avg_rating['count'] > 0 ) {
                                        ?>
                                          <div class="fds-rating-stars">
                                              <span class="fds-rating-stars-fill" style="width: <?php echo $restaurant_avg_rating['percentage']; ?>%;"></span>
                                          </div>
                                          <span class="fds-restaurant-rate-count">
                                            <?php
                                            echo $restaurant_avg_rating['count'] . " ";
                                            echo ( $restaurant_avg_rating['count'] > 1 ) ? esc_html__('reviews', 'wp-foodsearch') : esc_html__('review', 'wp-foodsearch') ;
                                            ?>
                                            <small class="fds-rating-point"><?php echo $restaurant_avg_rating['rating']; ?></small>
                                          </span>
                                          
                                        <?php } ?>
                                          <div class="fds-restaurant-list-option">
                                            <?php
                                            $food_cuisine = get_the_terms(get_the_id(), "food_cuisine");
                                            if ( $food_cuisine ) {
                                            ?>
                                              <div class="fds-option-child">
                                                <i class="fds-icon fds-cutlery-line"></i>
                                                <?php
                                                $counter = 0;
                                                foreach ( $food_cuisine as $val ) {
                                                  $counter++;
                                                ?>
                                                  <a href="javascript:foodsearch_cuisine_type(<?php echo $val->term_id; ?>)" class="fds-link fds-dessert"><?php echo $val->name; echo ($counter < count($food_cuisine) ) ? "," : ""; ?></a>
                                                <?php
                                                }
                                                ?>
                                              </div>
                                            <?php
                                            }
                                            if ( $attr['show_distance'] ) { ?>
                                              <div class="fds-option-child fds-distance<?php echo $_GET['offset'] + $attr['number_of_items']; ?>"><i class="fds-icon fds-pin-line"></i> 
                                                <!-- <span id="loc_<?php the_id(); ?>">0 </span> -->
                                                <div>
                                                <?php 
                                                  $kmc = 1.60934;
                                                if(isset($listing['items'][$post->ID])){                                              
                                                    if($foodsearch_plugin_settings['location_settings']['disply_distance']!='mile'){
                                                      echo number_format($listing['items'][$post->ID]['distance']*$kmc, 2);
                                                    }
                                                    else{
                                                      echo number_format($listing['items'][$post->ID]['distance'], 2);
                                                    }
                                                } else {
                                                  echo 'Not Found';
                                                }
                                                  ?>    
                                              </div>
                                                
                                                <?php esc_html_e($foodsearch_plugin_settings['location_settings']['disply_distance'], 'wp-foodsearch') ?>
                                               
                                              </div>
                                            <?php
                                            }
                                            if ( $attr['show_delFee'] ) {
                                              $del_fee = get_post_meta(get_the_id(), 'foodsearch_delivery_fee', true);
                                              if ( $del_fee !== "" ){
                                            ?>
                                              <div class="fds-option-child">
                                                <a href="javascript:void()" class="fds-link fds-delivery-fee"><i class="fds-icon fds-dollar-coin-circle"></i>
                                                  <?php
                                                  if ( $del_fee == 0 ) {
                                                    esc_html_e('free delivery', 'wp-foodsearch');
                                                  }
                                                  else echo esc_html('delivery fee: $', 'wp-foodsearch') . $del_fee;
                                                  ?>
                                                </a>
                                              </div>
                                            <?php
                                              }
                                            }
                                            if ( $attr['show_timing'] ) {
                                            ?>
                                            <?php
                                            $open_close = '';
                                            $open_close_class = '';
                                                    date_default_timezone_set('Asia/karachi');
                                                    $Today = strtolower(date('l'));
                                                    $currentTime = strtotime(date('H:i'));
                                                    $openToday = get_post_meta(get_the_ID(), 'restaurant_' . $Today . '_status', true);
                                                    $openingtime = get_post_meta(get_the_ID(), 'restaurant_' . $Today . '_opening_hour', true);
                                                    $closetime = get_post_meta(get_the_ID(), 'restaurant_' . $Today . '_closing_hour', true);
                                                    if ($openToday == 1 && $currentTime >= strtotime($openingtime) && $currentTime <= strtotime($closetime)) {
                                                      $open_close = esc_html('opens at ', 'wp-foodsearch') . $openingtime;
                                                      $open_close_class = 'fds-opening-time';
                                                    } else {
                                                      $open_close = esc_html('now closed', 'wp-foodsearch');
                                                      $open_close_class = 'fds-closing-time';
                                                    }
                                                ?>
                                            <div class='fds-option-child'>
                                              <span class="<?php echo $open_close_class; ?>"><i class="fds-icon fds-clock-fast"></i><?php echo $open_close; ?></span>
                                            </div>
                                            <?php } ?>
                                        </div>
                                        <div class="fds-restaurant-grid-status">
                                            <?php
                                                if ( get_post_meta(get_the_id(), 'foodsearch_order_process_type', true) === "both" || get_post_meta(get_the_id(), 'foodsearch_order_process_type', true) === "takeaway" ){
                                            ?>
                                                    <a href="javascript:void()" class="fds-link fds-take-away"><i class="fds-icon fds-tick-circle-line"></i> <?php esc_html_e('take away', 'wp-foodsearch') ?></a>
                                            <?php
                                                }
                                                if ( get_post_meta(get_the_id(), 'foodsearch_order_process_type', true) === "both" || get_post_meta(get_the_id(), 'foodsearch_order_process_type', true) === "delivery" ){
                                            ?>
                                                    <a href="javascript:void()" class="fds-link fds-delivery-option"><i class="fds-icon fds-tick-circle-line"></i> <?php esc_html_e('delivery', 'wp-foodsearch') ?></a>
                                            <?php
                                                }
                                            ?>
                                        </div>
                                        <div class="fds-restaurant-grid-food-type">
                                            <?php
                                            if ($cats){
                                                $counter = 0;
                                            ?>
                                                <span><?php esc_html_e('type of food :', 'wp-foodsearch') ?></span>
                                                <?php
                                                foreach ($cats as $cat){
                                                    $counter++;
                                                    if ($counter > 3) {
                                                        echo " ...";
                                                        break;
                                                    }
                                                ?>
                                                <a class="fds-link" href="#"><?php echo $cat->name; ?>,</a>
                                            <?php
                                                }
                                            }
                                            ?>
                                        </div>
                                    </div>
                                    <div class="fds-restaurant-grid-menu">
                                      <?php
                                        $min_delivery_order = get_post_meta(get_the_id(), 'foodsearch_min_delivery_order', true);
                                        if ( !empty($min_delivery_order) ){
                                      ?>
                                        <a href="javascript:void()" class="fds-link fds-min-order"><?php esc_html_e('min order', 'wp-foodsearch') ?> <strong>$<?php echo $min_delivery_order; ?></strong></a>
                                      <?php } ?>
                                        <?php if ( $attr['show_menuBTN'] ) { ?>
                                          <a class="fds-link active" href="<?php the_permalink($post->ID); ?>"><i class="fds-icon fds-menu-one"></i> <?php esc_html_e('view menu', 'wp-foodsearch') ?></a>
                                        <?php } ?>
                                    </div>
                                </div>
                            </div>

                        <?php
                      }
                    }
                    ?>
            <!--// Grid View //-->
<?php
        }
        else {
?>
            <!--// List View //-->
                    <?php
                    if ( $listing['posts'] ) {
                      foreach ( $listing['posts'] as $post ) {
                        $cats = get_the_terms(get_the_id(), "food_item_cat");
                        $restaurant_avg_rating = User_Reviews::restaurant_avg_review_rate(get_the_id());
                            $bg = get_the_post_thumbnail_url();
                            if ( empty($bg) ) $bg = plugin_dir_url(__FILE__)."../images/no-image.jpg";
                    ?>

                                    <div class="fds-list-item fds-col-1">
                                        <div class="fds-restaurant-list-wrap">
                                            <?php if ( $attr['show_image'] ) { ?>
                                              <div class="fds-item-thumb"><a class="fds-link" href="<?php the_permalink($post->ID); ?>"><img src="<?php echo $bg ?>" alt="<?php echo get_the_title($post->ID); ?>"></a></div>
                                            <?php } ?>
                                            <div class="fds-restaurant-list-text">
                                                <div class="fds-restaurant-text-main">
                                                    <div class="fds-restaurant-text-inn">
                                                        <?php if ( $attr['show_title'] ) { ?>
                                                          <h2 class="fds-ps-title fds-post-title"><a class="fds-link" href="<?php the_permalink($post->ID); ?>"><?php echo get_the_title($post->ID); ?></a></h2>
                                                        <?php
                                                        }
                                                        if ( isset($attr['show_reviews']) && $attr['show_reviews'] && isset($restaurant_avg_rating['count']) && $restaurant_avg_rating['count'] > 0 ) {
                                                        ?>
                                                          <div class="fds-rating-stars">
                                                              <span class="fds-rating-stars-fill" style="width: <?php echo $restaurant_avg_rating['percentage']; ?>%;"></span>
                                                          </div>
                                                          <span class="fds-restaurant-rate-count">
                                                            <?php
                                                            echo $restaurant_avg_rating['count'] . " ";
                                                            echo ( $restaurant_avg_rating['count'] > 1 ) ? esc_html__('reviews', 'wp-foodsearch') : esc_html__('review', 'wp-foodsearch') ;
                                                            ?>
                                                            <small class="fds-rating-point"><?php echo $restaurant_avg_rating['rating']; ?></small>
                                                          </span>
                                                        <?php } ?>
                                                    </div>
                                                    <?php
                                                      if ( $attr['show_favourite'] ) {
                                                        Common_Functions::restaurant_fav_btn_html(get_the_id(), 'list', $u_id );
                                                      }
                                                    ?>

                                                </div>
                                                <div class="fds-restaurant-list-option">
                                                  <?php
                                                  $food_cuisine = get_the_terms(get_the_id(), "food_cuisine");
                                                  if ( $food_cuisine ) {
                                                  ?>
                                                    <div class="fds-option-child">
                                                      <i class="fds-icon fds-cutlery-line"></i>
                                                      <?php
                                                      $counter = 0;
                                                      foreach ( $food_cuisine as $val ) {
                                                        $counter++;
                                                      ?>
                                                        <a href="javascript:foodsearch_cuisine_type(<?php echo $val->term_id; ?>)" class="fds-link fds-dessert"><?php echo $val->name; echo ($counter < count($food_cuisine) ) ? "," : ""; ?></a> 
                                                      <?php
                                                      }
                                                      ?>
                                                    </div>
                                                  <?php
                                                  }
                                                  if ( $attr['show_distance'] ) { ?>
                                                    <div class="fds-option-child fds-distance<?php echo $_GET['offset'] + $attr['number_of_items']; ?>"><i class="fds-icon fds-pin-line"></i>
                                                      <!-- <span id="loc_<?php the_id(); ?>">0</span> -->
                                                      
                                                <div>
                                                  <?php 
                                                  $kmc = 1.60934;
                                                if(isset($listing['items'][$post->ID])){
                                                 
                                                    if($foodsearch_plugin_settings['location_settings']['disply_distance']!='mile'){
                                                      echo number_format($listing['items'][$post->ID]['distance']*$kmc, 2);
                                                    }
                                                    else{
                                                      echo number_format($listing['items'][$post->ID]['distance'], 2);
                                                    }
                                                } else {
                                                  echo 'Not Found';
                                                }
                                                  ?></div>
                                                      <?php esc_html_e($foodsearch_plugin_settings['location_settings']['disply_distance'], 'wp-foodsearch') ?>
                                                    </div>
                                                  <?php
                                                  }
                                                    if ( $attr['show_delFee'] ) {
                                                      $del_fee = get_post_meta(get_the_id(), 'foodsearch_delivery_fee', true);
                                                      if ( $del_fee !== "" ){
                                                    ?>
                                                      <div class='fds-option-child'>
                                                        <a href="javascript:void()" class="fds-link fds-delivery-fee"><i class="fds-icon fds-dollar-coin-circle"></i>
                                                          <?php
                                                          if ( $del_fee == 0 ) {
                                                            esc_html_e('free delivery', 'wp-foodsearch');
                                                          }
                                                          else echo esc_html('delivery fee: $', 'wp-foodsearch') . $del_fee;
                                                          ?>
                                                        </a>
                                                      </div>
                                                    <?php
                                                      }
                                                    }
                                                    ?>
                                                    <?php if ( $attr['show_timing'] ) { ?>
                                                      <?php
                                                      $open_close = '';
                                                      $open_close_class = '';
                                                              date_default_timezone_set('Asia/karachi');
                                                              $Today = strtolower(date('l'));
                                                              $currentTime = strtotime(date('H:i'));
                                                              $openToday = get_post_meta(get_the_ID(), 'restaurant_' . $Today . '_status', true);
                                                              $openingtime = get_post_meta(get_the_ID(), 'restaurant_' . $Today . '_opening_hour', true);
                                                              $closetime = get_post_meta(get_the_ID(), 'restaurant_' . $Today . '_closing_hour', true);
                                                              if ($openToday == 1 && $currentTime >= strtotime($openingtime) && $currentTime <= strtotime($closetime)) {
                                                                $open_close = esc_html('opens at ', 'wp-foodsearch') . $openingtime;
                                                                $open_close_class = 'fds-opening-time';
                                                              } else {
                                                                $open_close = esc_html('now closed', 'wp-foodsearch');
                                                                $open_close_class = 'fds-closing-time';
                                                              }
                                                          ?>
                                                      <div class='fds-option-child'>
                                                        <span class="<?php echo $open_close_class; ?>"><i class="fds-icon fds-clock-fast"></i><?php echo $open_close; ?></span>
                                                      </div>
                                                      <?php } ?>
                                                </div>
                                                <div class="fds-restaurant-list-status-deliver">
                                                    <?php
                                                    if ( get_post_meta(get_the_id(), 'foodsearch_order_process_type', true) === "both" || get_post_meta(get_the_id(), 'foodsearch_order_process_type', true) === "takeaway" ){
                                                    ?>
                                                        <a href="javascript:void()" class="fds-link fds-take-away"><i class="fds-icon fds-tick-circle-line"></i> <?php esc_html_e('take away', 'wp-foodsearch') ?></a>
                                                    <?php
                                                    }
                                                    if ( get_post_meta(get_the_id(), 'foodsearch_order_process_type', true) === "both" || get_post_meta(get_the_id(), 'foodsearch_order_process_type', true) === "delivery" ){
                                                    ?>
                                                        <a href="javascript:void()" class="fds-link fds-delivery-option"><i class="fds-icon fds-tick-circle-line"></i> <?php esc_html_e('delivery', 'wp-foodsearch') ?></a>
                                                    <?php
                                                    }
                                                    ?>
                                                    <?php
                                                      $min_delivery_order = get_post_meta(get_the_id(), 'foodsearch_min_delivery_order', true);
                                                      if ( !empty($min_delivery_order) ){
                                                    ?>
                                                      <a href="javascript:void()" class="fds-link fds-min-order"><?php esc_html_e('min order', 'wp-foodsearch') ?> <strong>$<?php echo $min_delivery_order; ?></strong></a>
                                                    <?php } ?>
                                                    <?php if ( $attr['show_menuBTN'] ) { ?>
                                                      <a href="<?php the_permalink($post->ID); ?>" class="fds-link active"><?php esc_html_e('view menu', 'wp-foodsearch') ?></a>
                                                    <?php } ?>
                                                </div>
                                                <div class="fds-restaurant-list-food-type">
                                                    <?php
                                                    if ($cats){
                                                        $counter = 0;
                                                    ?>
                                                        <span><?php esc_html_e('type of food :', 'wp-foodsearch') ?></span>
                                                        <?php
                                                            foreach ($cats as $cat){
                                                                $counter++;
                                                                if ($counter > 3) {
                                                                    echo " ...";
                                                                    break;
                                                                }
                                                            ?>
                                                                <a class="fds-link" href="#"><?php echo $cat->name; ?>,</a>
                                                        <?php
                                                            }
                                                    }
                                                    ?>
                                                </div>
                                            </div>
                                        </div>
                                    </div>

                        <?php
                      }
                    }
                    ?>
            <!--// List View //-->
          <?php } ?>
      </div>

      <?php
      if ( isset($attr['pagination']) && $attr['pagination'] == "numbers" && $attr['number_of_items'] < $listing['total'] ) {
        // URL base depends on permalink settings.
        global $wp_rewrite;
        $format  = $wp_rewrite->using_index_permalinks() && ! strpos( $pagenum_link, 'index.php' ) ? 'index.php/' : '';
        $format .= $wp_rewrite->using_permalinks() ? user_trailingslashit( $wp_rewrite->pagination_base . '/%#%', 'paged' ) : '?paged=%#%';

        // echo foodsearch_pagination_number($listing['total'], $attr['number_of_items'], $_GET['offset']);
        $args = array(
              'base'               => get_pagenum_link(1) . '%_%',
              'format'             => $format,
              'total'              => ceil($listing['total'] / $attr['number_of_items']),
              'current'            => $current_page,
              'show_all'           => false,
              'prev_next'          => true,
              'prev_text'          => __('« Previous'),
              'next_text'          => __('Next »'),
              'type'               => 'plain',
              'add_args'           => false,
              'add_fragment'       => '',
              'before_page_number' => '',
              'after_page_number'  => ''
          );
        echo "<div class='fds-pagination'>" . paginate_links($args) . "</div>";
      }
      ?>

      <input type="hidden" id="total_items" value="<?php echo $listing['total'] ?>">
      <input type="hidden" id="offset" name="offset" value="<?php echo $_GET['offset'] + $attr['number_of_items'] ?>">
      <div id="loader"></div>
      
      
